import express from "express";
import { ensureLoggedIn } from "connect-ensure-login";

import { sendResponse } from "../../../libs/format";

import Me from "../../../middleware/Me";

// eslint-disable-next-line new-cap
const router = express.Router();

router
    .route("/")
    .patch(ensureLoggedIn("/connexion"), async (req, res, next) => {
        try {
            const me = new Me(req);
            const data = await me.patchMe();

            return sendResponse(req, res, data);
        } catch (err) {
            return next(err);
        }
    });

export default router;
